const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const bloodGroupService = require("./bloodGroup.service");

router.post("/create", authorize(), create);
router.post("/", authorize(), getAll);
router.post("/option", authorize(), option);
router.post("/option-free", option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put("/enabled/:id", authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

/**
 * Create a new bloodGroup
 * @param {Object} req.body - The bloodGroup data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created bloodGroup
 */
function create(req, res, next) {
	bloodGroupService
		.create(req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Get a list of all bloodGroups
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of bloodGroups
 */
function getAll(req, res, next) {
	bloodGroupService
		.getAll(req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Get an array of bloodGroup objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of bloodGroup objects
 */
function option(req, res, next) {
	bloodGroupService
		.option(req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Count the number of bloodGroups matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of bloodGroups
 */
function count(req, res, next) {
	bloodGroupService
		.count(req.query)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Update an existing bloodGroup
 * @param {number} req.params.id - The bloodGroup ID to be updated
 * @param {Object} req.body - The bloodGroup data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated bloodGroup
 */
function update(req, res, next) {
	bloodGroupService
		.update(req.params.id, req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Enable or disable a bloodGroup
 * @param {number} req.params.id - The bloodGroup ID to be enabled/disabled
 * @param {Object} req.body - The bloodGroup data to be updated
 * @param {boolean} req.body.enabled - The enabled status of the bloodGroup
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the enable/disable process
 */
function enabled(req, res, next) {
	bloodGroupService
		.enabled(req.params.id, req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Delete a bloodGroup
 * @param {number} req.params.id - The bloodGroup ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
	bloodGroupService
		.delete(req.params.id)
		.then((result) => res.json(result))
		.catch(next);
}
